'shellh2i 7.4.03 timer starts before sndrec to avoid NT/XP delay
'shellh2h 27.4.02 cls in view print to speed up sndrec launch
'shellh2g 27.4.02 splitted at blanks into word-sized wavs
'shellh2f 26.4.02 classic with one big hell.wav
'shellh2e 26.4.02 "sndrec2" and cls and timer
'shellh2d 26.4.02 synchronization using "rundll32" and locked .wav file
'shellh2b 26.4.02 synchronization using "start sndrec"
'shellh2  25:4.02 realtime wav generation using SHELL
'ex hell1g: DF6NM 06.10.00
'ex bmftwav1 27.4.99

'mni tnx to Cesare, I5TGC for his contributions and hints!

 DEFLNG A-Z

 CLS
 PRINT " -------------------  Chirped Multitone Hell v.2i by DF6NM -------------------"

 VIEW PRINT 2 TO 24

 path$ = "" 'define path in .pif
 'path$ = "..\fft\bmp_ff~1\hell\shellhel\"
 'path$ = "..\hell\"
 'dos box background activity should not be disabled in .pif

 samplerate = 6000
 fbaseHz! = 2210
 spcexp = 13

 'sndcomm$ = "C:\WINDOWS\rundll32.exe C:\WINDOWS\SYSTEM\amovie.ocx,RunDll /play /close "
 'amovie locks file, but occupies soundchip input also
 sndcomm$ = "sndrec32 /play /close "

 height = 8
 colsfnt = 8
 'colsfnt1 = colsfnt  'full char width incl. spacing
 colsfnt1 = colsfnt - 1 'leave out last column
 cols = colsfnt1 + 1

 spcexpm = 14
 samplespercolm = 2 ^ spcexpm
 costablen = 1024

 DIM wt%(samplespercolm - 1), ct%(costablen - 1)
 DIM s1%(samplespercolm - 1), s2%(samplespercolm - 1)
 DIM bmp%(colsfnt - 1, height - 1)
 DIM frq(height - 1), ph0(height - 1)

 OPEN path$ + "chrmask.txt" FOR INPUT AS 1
  chrmask$ = INPUT$(LOF(1), 1)
 CLOSE 1

 samplespercol = 2 ^ spcexp
 fbase1! = fbaseHz!
 aw! = .55 / SQR(height)
 GOSUB calccostab

 t2! = 0
 quit = 0

 GOSUB calcfreqs
 'PRINT "freq"; fl!; "..."; fu!; "Hz,"; dur!; "s/char, w ="; spcexp
 GOSUB calcwtab

 WHILE quit = 0
  clin = CSRLIN: VIEW PRINT 25 TO 25
 
  CLS : PRINT fl!; "..."; fu!; "Hz,"; dur!; "s/char";
  PRINT " - Please enter text or return only";
 
  VIEW PRINT 2 TO 24: LOCATE clin
 
  INPUT ; ">", in$
 
  IF in$ = "" THEN
   GOSUB setparameters
  ELSE
   ftext$ = in$
   GOSUB playtext
   PRINT
  END IF
 WEND

ende:
 PRINT "bye"
END

'============================

playtext:
  clin = CSRLIN: VIEW PRINT 25 TO 25
 
  blankdur! = .5 * duration!: IF blankdur! < .5 THEN blankdur! = .5
  i$ = ""
  blankp = 0
  WHILE blankp < LEN(ftext$) AND i$ <> CHR$(27)
   oldblankp = blankp + 1
   blankp = INSTR(oldblankp, ftext$, " ")
   IF blankp = 0 THEN blankp = LEN(ftext$) + 1
   text$ = MID$(ftext$, oldblankp, blankp - oldblankp) '+ "*"
   IF LEN(text$) > 0 THEN
    file$ = path$ + "hell" + CHR$(48 + filenr) + ".wav"
    filenr = 1 - filenr
    CLS : PRINT "preparing ";
    GOSUB createwav
    CLS : PRINT "waiting to send "; text$;
    WHILE TIMER < t2!
     IF INKEY$ = CHR$(27) THEN blankp = LEN(ftext$): GOTO esc
    WEND
    CLS : PRINT "sending "; text$;
    t2! = TIMER + LEN(text$) * duration! + blankdur! 'now before SHELL
    ' Win95/98: Shell returnes immediately after launching sndrec
    ' NT/XP: Shell returned only when finished playing
    SHELL sndcomm$ + file$
    FOR ndel = 1 TO 100: CLS : NEXT ndel 'speedup sndrec start
    't2! = ...
   ELSE
    t2! = t2! + duration! * .5
   END IF
   IF t2! > 24! * 3600! THEN t2! = t2! - 24! * 3600!
esc:
  WEND
 
  'CLS : PRINT "Please enter text and return, return only to change parameters or quit.";
  VIEW PRINT 2 TO 24: LOCATE clin
 
 RETURN

times:
  PRINT TIMER
 RETURN

createwav:
 OPEN file$ FOR OUTPUT AS 2

 samples = cols * samplespercol * LEN(text$)
 GOSUB calcwavhdr
 PRINT #2, h2$;
 
 fileblocksize = samplespercol
 IF fileblocksize > 4096 THEN fileblocksize = 4096
 out$ = STRING$(fileblocksize, 0)

 FOR ntext = 1 TO LEN(text$)
  nl = ASC(MID$(text$, ntext, 1))
  PRINT CHR$(nl);
  chrlen = height * colsfnt + 2
  FOR y = 0 TO height - 1
   FOR x = 0 TO colsfnt - 1
    chrm$ = MID$(chrmask$, (nl - 32) * chrlen + x * colsfnt + y + 1, 1)
    bmp%(x, y) = -(chrm$ = "1")
   NEXT x
  NEXT y

  FOR x = 0 TO colsfnt1
   FOR nt% = 0 TO samplespercol - 1
    s1%(nt%) = s2%(nt%)
    s2%(nt%) = 0
   NEXT nt%
   IF x < colsfnt1 THEN
    FOR y = 0 TO height - 1
     ph% = ph0(y) AND phmask%
     fr% = frq(y)
     IF bmp%(x, y) > 0 THEN
      IF cshift% THEN
       FOR nt% = 0 TO samplespercol - 1
        ph% = (ph% + fr%) AND phmask%
        s2%(nt%) = s2%(nt%) + ct%(ph% \ cshift%)
       NEXT nt%
      ELSE
       FOR nt% = 0 TO samplespercol - 1
        ph% = (ph% + fr%) AND phmask%
        s2%(nt%) = s2%(nt%) + ct%(ph% * clshift%)
       NEXT nt%
      END IF
     END IF
    NEXT y
   END IF
   
   FOR nt% = 0 TO samplespercol - 1
    s1%(nt%) = (s1%(nt%) * wt%(nt%) + s2%(nt%) * wt%(samplespercol - 1 - nt%)) \ 128
   NEXT nt%
  
   fbmax = fileblocksize
   FOR nt0% = 0 TO samplespercol - 1 STEP fileblocksize
    IF nt0% + fbmax > samplespercol THEN fbmax = samplespercol - nt0%
    FOR nt1% = 0 TO fbmax - 1
     s% = s1%(nt0% + nt1%) + 128
     IF s% > 255 THEN s% = 255
     IF s% < 0 THEN s% = 0
     MID$(out$, nt1% + 1, 1) = CHR$(s%)
    NEXT nt1%
    PRINT #2, out$;
   NEXT nt0%

  NEXT x
 NEXT ntext
 CLOSE 2
 RETURN


calcwavhdr:
 samples2 = 2 * ((samples + 1) \ 2)
 bits = 8
 channels = 1
 bytespersample = bits \ 8 * channels
 file2len = 44& + samples2 * bytespersample 'hdrlen=44, not 48
 h2$ = "RIFF" + MKL$(file2len - 8)
 h2$ = h2$ + "WAVEfmt " + MKL$(16)
 h2$ = h2$ + MKI$(1) + MKI$(channels)
 h2$ = h2$ + MKL$(samplerate)
 h2$ = h2$ + MKL$(samplerate * bytespersample)
 h2$ = h2$ + MKI$(bytespersample) + MKI$(bits)
 h2$ = h2$ + "data" + MKL$(samples)
RETURN


calccostab:
 pi! = 4! * ATN(1)
 ac! = 127
 FOR nt = 0 TO costablen - 1
  ct%(nt) = ac! * COS(nt * 2 * pi! / costablen)
 NEXT nt
RETURN


setparameters:
   clin = CSRLIN: VIEW PRINT 25 TO 25
   CLS : PRINT " R repeat, F +-base freq, W bandw. 6..14, S samplerate, Q quit ";
   INPUT ; ">", in$: in$ = UCASE$(in$)
   VIEW PRINT 2 TO 24: LOCATE clin
  
   IF in$ = "R" THEN PRINT ">"; ftext$: GOTO playtext
   ip% = INSTR(in$, "Q"): IF ip% > 0 THEN quit = 1: RETURN
   ip% = INSTR(in$, "S"): IF ip% > 0 THEN sampler1 = VAL(MID$(in$, ip% + 1))
    IF sampler1 > 0 THEN samplerate = sampler1
   ip% = INSTR(in$, "F"): IF ip% > 0 THEN fbase1! = VAL(MID$(in$, ip% + 1))
    IF ABS(fbase1!) < samplerate / 2 THEN fbaseHz! = fbase1!
   ip% = INSTR(in$, "W"): IF ip% > 0 THEN spcexp = VAL(MID$(in$, ip% + 1))
    IF spcexp >= 2 AND spcexp <= spcexpm THEN samplespercol = 2 ^ spcexp
   GOSUB calcfreqs
   GOSUB calcwtab
   'PRINT "freq"; fl!; "..."; fu!; "Hz,"; dur!; "s/char, w ="; spcexp
 RETURN

calcfreqs:
  phmask% = samplespercol - 1
  cshift% = samplespercol \ costablen
  clshift% = costablen \ samplespercol
  f0 = fbaseHz! * samplespercol / samplerate'??
  duration! = cols * samplespercol / samplerate
  FOR ny = 0 TO height - 1
   frq(ny) = 1 * ny + f0
   ph0(ny) = costablen * cshift% * (ny * ny / 2 / height)
  NEXT ny
  fl! = .1 * INT(.5 + 10! * frq(0) * samplerate / samplespercol)
  fu! = .1 * INT(.5 + 10! * frq(height - 1) * samplerate / samplespercol)
  dur! = .01 * INT(.5 + 100 * duration!)
 RETURN


calcwtab:
 FOR nt = 0 TO samplespercol - 1
  wt%(nt) = aw! * 128 * (1 + COS(nt * pi! / samplespercol)) / 2
 NEXT nt
RETURN

